// Code generated by mockery v2.20.0. DO NOT EDIT.

package mockclients

import (
	context "context"

	mock "github.com/stretchr/testify/mock"

	types "gitlab.com/infor-cloud/martian-cloud/tharsis/tharsis-sdk-go/pkg/types"
)

// TerraformModule is an autogenerated mock type for the TerraformModule type
type TerraformModule struct {
	mock.Mock
}

// CreateModule provides a mock function with given fields: ctx, input
func (_m *TerraformModule) CreateModule(ctx context.Context, input *types.CreateTerraformModuleInput) (*types.TerraformModule, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.TerraformModule
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateTerraformModuleInput) (*types.TerraformModule, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateTerraformModuleInput) *types.TerraformModule); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.TerraformModule)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.CreateTerraformModuleInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteModule provides a mock function with given fields: ctx, input
func (_m *TerraformModule) DeleteModule(ctx context.Context, input *types.DeleteTerraformModuleInput) error {
	ret := _m.Called(ctx, input)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.DeleteTerraformModuleInput) error); ok {
		r0 = rf(ctx, input)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetModule provides a mock function with given fields: ctx, input
func (_m *TerraformModule) GetModule(ctx context.Context, input *types.GetTerraformModuleInput) (*types.TerraformModule, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.TerraformModule
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetTerraformModuleInput) (*types.TerraformModule, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetTerraformModuleInput) *types.TerraformModule); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.TerraformModule)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetTerraformModuleInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetModules provides a mock function with given fields: ctx, input
func (_m *TerraformModule) GetModules(ctx context.Context, input *types.GetTerraformModulesInput) (*types.GetTerraformModulesOutput, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.GetTerraformModulesOutput
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetTerraformModulesInput) (*types.GetTerraformModulesOutput, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetTerraformModulesInput) *types.GetTerraformModulesOutput); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.GetTerraformModulesOutput)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetTerraformModulesInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateModule provides a mock function with given fields: ctx, input
func (_m *TerraformModule) UpdateModule(ctx context.Context, input *types.UpdateTerraformModuleInput) (*types.TerraformModule, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.TerraformModule
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.UpdateTerraformModuleInput) (*types.TerraformModule, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.UpdateTerraformModuleInput) *types.TerraformModule); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.TerraformModule)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.UpdateTerraformModuleInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

type mockConstructorTestingTNewTerraformModule interface {
	mock.TestingT
	Cleanup(func())
}

// NewTerraformModule creates a new instance of TerraformModule. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
func NewTerraformModule(t mockConstructorTestingTNewTerraformModule) *TerraformModule {
	mock := &TerraformModule{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
